#!/usr/bin/python3
# -*- coding: utf-8 -*-

## Editorhilfe :-)
#rowdict_list=a_db.get_rowdict_list
#rowdict=a_db.get_one_rowdict
#item_list=a_db.get_column_list
#item=a_db.get_first_element
#flag=a_db.get_existenz

'''
________________________________________________________________________
 a_admin_hilfen.py                                                       
 This file is free software under         
     the terms of the GPL without any warranty - see the file COPYING 
 Diese Datei ist  Freie Software gemäß
             der GPL ohne jegliche Garantie - siehe die Datei COPYING 
________________________________________________________________________

 a_admin_hilfen.py enthält nur die konstanten Hilfstexte für das Administratorinterface
 Dieses Modul wird nicht geladen, wenn der user kein Administrator ist.
________________________________________________________________________
'''

mailcode_hilfe='''
<b>Hilfe zum Mailcode</b>
Ist das System entsprechend konfiguriert, so können Schüler sich mit einem Mailcode krankmelden.
Dieser Code wird für jeden Schüler automatisch erzeugt und ist natürlich eindeutig.<br>
Hat ein Schüler den Code verloren, so sollte ein neuer erzeugt werden um Mißbrauch zu verhindern.
<br><br>
Auf drei Arten findet man den Mailcode eines Schülers:<br>
- in den Stammdaten in der Spalte neben den Schülernamen<br>
- in einer hier erzeugbaren csv-Datei, die alle Mailcodes enthält<br>
- in einem hier erzeugbaren Serienbrief, der für jeden Schüle eine Seite mit dem Code und Bedienungshinweisen enthält. (Ausdruck nur mit Firefox oder LibreOffice)'''

rechte_hilfe='''
<b> Hilfe zum <i>Rechte festlegen</i></b>
In diesem Dialogfeld können Sie einem User  bestimmte Rechte zuweisen.<br>
Der Name kann entweder ausgewählt werden oder neu eingegeben werden, falls er noch nicht angelegt war,
 z.B. bei Sekretariatskräften. Bitte identische Schreibweise wie bei den bestehenden Usern anstreben. 
Man kann dem User sofort oder auch nachträglich Rechte zuweisen und ändern.
 
Welche Rechte der User bereits besitzt steht in der Ansicht <i>Stammdaten</i>.
Diese bisherigen Rechte werden komplett überschrieben, wenn man ihm hier Rechte einräumt.<br>
<br>Jedes Recht bezieht sich immer auf eine Stufe.<br><br>
<strong>Verwaltungsrechte</strong> beinhalten das Setzen von (auch allgemeinen) Attestpflichten, dem Löschen von Einträgen usw..
<br><br>
<strong>Sekretariatsrechte</strong> sind eine Alternative, bei der alle Entschuldigungen und vorgelegte Atteste eingetragen werden können.
<br><br>
<strong>Stufenlehrerrechte</strong> ermöglichen dem User bei jedem Schüler in der Stufe Absenzen und Befreiungen einzutragen - aber keine Entschuldigungen. 
<br><br>
Nimmt man dem User alle Sonderrechte weg, so kann er nur in den Kursen, die er unterrichtet, Absenzen und Befreiungen eintragen!
'''

passwort_hilfe='''<b>Hilfe zu Lehrerpasswörter</b>
Als Administrator können Sie der Kollegin / dem Kollegen, die/den Sie in der Auswahl gewählt haben,
ein neues Passwort geben. Geben Sie es zweimal ein und klicken Sie auf <i>Ändern</i>.
Dieses Passwort müssen Sie dem Kollegen selber mitteilen!<br><br>

Jeder Lehrer-Account, der <i>automatisch</i> angelegt wird (beim Einlesen der Kurslisten),
erhält automatisch ein <i>generiertes Passwort</i>. Diese Passwörter kann man als Liste in einer
csv-Datei exportieren um z.B. einen eigenen Seriebrief anzulegen.
<br><br>
Eine eigene Serienbrieffunktion ermöglicht aber auch den Export als HTML-Datei, 
die LibreOffice und Firefox (nicht Chrome) im Ausdruck auf einzelne Seiten verteilen - 
je eine für jede(n) Lehrer(in).<br>
Die verwendete Vorlage kann man in dem Dialog <i>Dateien für Serienbriefe einlesen</i> festlegen.
(Von der Homepage absenzen.de lassen sich die Originale herunterladen, anhand deren Aufbau man eigene gestalten kann)
'''

upload_hilfe='''
<b>Hilfe zum Hochladen von Dateien</b>
Sie können getrennt Listen hochladen für:
<ul><li>Oberstufenkurse (legt Kurse, Lehrer und Schüler an und verknüpft diese)</li>
    <li>Schüler (legt Klassen und Schüler an und verknüpft diese)</li>
    <li>Lehrer (legt Lehrer (und ggf. Klassen) an und verknüpft Lehrer mit Klassen, in denen sie unterrichten)</li>
</ul>
Serienbriefe können im HTML-Format hochgeladen werden.
'''
uploadq_hilfe='''
<b>Hilfe zum Upload von Kurslisten</b>
<h3>Oberstufe (Q)</h3>
Die <i>Kurslisten</i> müssen in WinQD erzeugt und dann hier eingelesen werden.<br>
Details: <a href="http://absenzen.de">http://absenzen.de</a> -> Screenshots -> Administration<br>
Dabei werden für die Kursleiter Lehrer-Accounts angelegt (sofern sie noch nicht existieren) und die Schüler angelegt (sofern sie noch nicht existieren).<br>
Wird dieselbe Kursliste erneut eingelesen hat das keine Auswirkung. 
Liest man eine aktualisierte Kursliste ein, bei der sich z.B. nur einzelne Schüler geändert haben (Zu-/Abgänge, Kurswechsel) 
so bleiben alle Accounts und Schülerdaten (inkl. aller Absenzen) erhalten - die Schüler und Lehrer werden nur ggf. neu zugeordnet.<br>
Beginnen die Kursnamen nicht mit 1 für Q11 und 2 für Q12, so muss in den Einstellungen das Kurskriterium eingetragen werden!'''

uploadum_hilfe='''
<b>Hilfe zum Upload von Schülerlisten</b>
<h3>Unter- und Mittelstufe</h3>
Klassenlisten werden mit WinSV oder ASV erstellt. Dann als <i>Schülerliste</i> auswählen und einlesen.
Die Zeilen der Datei müssen so aussehen/beginnen (der Rest wird ignoriert):<br>
<pre>
ASV, in Codierung utf-8:               12;Anton Mustermann;5a
alt (WINSV), in Codierung iso-8859-1:  "5a"|"Anton Mustermann"</pre>
(die führende laufende Zahl bei ASV ist fakultativ)<br>
Hiermit werden sowohl die Schüler, als auch die Klassen angelegt, bestehende Schüler und Klassen aber nicht gelöscht oder geändert. 
Nur alle Zuordnungen zwischen Schülern und Klassen werden neu gesetzt.
Klassennamen, die mit Ziffern beginnen erhalten diese Zahl auch als Jahrgangsstufe, 
alle anderen werden der 10. Klasse, und damit der Mittelstufe zugeordnet.
<br>Uns so erzeugt man die Schülerliste in der ASV:<br><pre>Bearbeiten > Listengenerator
1. Reiter Definition:
   Listenname: 
      z.B. Absenzen Export Schulkürzel
2. Reiter Spaltengestaltung:
    Hauptspalte > Auswahl:
      Alphabetische Gesamtliste mit Zusatzspalte Klasse
3. Reiter Bericht testen:
   Ausgabeeinstellungen > CSV-Datei (getrennt durch Strichpunkte)
anwenden</pre>'''
uploadl_hilfe='''
<b>Hilfe zum Upload von Lehrerliste</b>
Die Zeilen müssen mit dem Lehrernamen beginnen und dann eine oder mehrere Klassen enthalten:
<pre>
ASV (utf-8):                 32;Gerd Gröber;7a, 9a_L, 9b_E, 9c
alt (-ernativ) (iso-8859-1): "Gerd Gröber"|"7a"|"9c"</pre>
(die führende laufende Zahl bei ASV ist fakultativ)<br>
Mehrere Zeilen mit demselben Lehrernamen kumulieren, Groß/Kleinschreibung der Klassen wird ignoriert, Ab dem Unterstrich wird der Klassenname abgeschnitten, da bei Absenzen! keine Teilklassen differenziert werden. 
Ein solcher Lehrer hat dieselben Rechte wie ein Kursleiter: er kann Schüler nur vermissen und befreien.
Ggf. werden Lehrer neu angelegt, Klassen müssen bereits existieren.<br>
Als nächstes sollten Sie im eigenen Dialog die Klassleiter festlegen.<br> 
Schließlich können Sie einzelnen Lehrern in den verschiedenen Stufen Verwaltungsrechte einräumen.
'''

serienbriefe_hilfe='''<b>Serienbriefe</b>
Das System kann drei Arten von Serienbriefen erstellen. Diese basieren auf HTML-Dateien, 
deren Vorlage man auf der Homepage herunterladen kann. Dann verändert man sie nach Wunsch und lädt sie hier hoch.
'''

einstellungen_hilfe='''<b>Einstellungen</b>
Verschiedene Werte können eingestellt werden. Jede Einstellung muss einzeln gespeichert werden!<br>
Jede Einstellmöglichkeit hat eine individuelle Hilfe.
'''

asvorlage_hilfe='''
<b>Hilfe für Absenzenstatus-Vorlage</b>
Den Status aller Absenzen eines Schülers kann man für einen Schüler oder für alle Schüler 
auf je einer Seite (im Firefox) ausdrucken lassen. Dies geht in der Anzeige <i>Gesamtansicht</i>!
Die entsprechende Vorlage kann hier hochgeladen werden.'''

mcvorlage_hilfe='''
<b>Hilfe für Mailcode-Brief-Vorlage</b>
In diesen Admintools kann man einen Serienbrief erzeugen lassen, der für alle Schüler
einen Brief mit ihrem Mailcode und die Benutzungshinweise enthält.
Die entsprechende Vorlage kann hier hochgeladen werden.'''

pwvorlage_hilfe='''
<b>Hilfe für Passwort-Brief-Vorlage</b>
Bei den <i>Lehrerpasswörtern</i> kann man einen Serienbrief erzeugen lassen, der für alle Lehrer, 
die ein generiertes Passwort haben, einen Brief mit den nötigen Informationen erzeugt.
Die entsprechende Vorlage kann hier hochgeladen werden.'''

ab_loesch_hilfe='''
<b>Begrenzen von Absenzen</b>
<u>Fixieren:</u><br>
Hier können alle Absenzen vor einem bestimmten Datum (das aktuelle wird vorgeschlagen) fixiert werden.<br>
Gleichzeitig wird damit eine Halbjahresgrenze festgelegt. Es können dann keine Absenzen vor diesem Datum mehr eingtragen werden.<br>
In den Statistiken ist nun eine Halbjahreswahl möglich. In anderen Schuljahren dann nicht mehr! Der Vorgang ist reversibel, da nur dieses Datum vermerkt und beachtet wird.<br>
Auf die Frage "Sicher?" antwortet man mit "ja"<br><br>

<u>Löschen:</u><br>
Das Löschen aller Absenzen vor einem Stichtag wird typischerweise zum Schuljahresbeginn durchgeführt und 
bewirkt eine echte Vernichtung der Absenzen - der Speicherplatz wird auch wieder frei.<br>
Damit kann man Datenschutzrichtlinien einhalten, die z.B. vorgeben, dass Schülerdaten ein Jahr nach dem Ausscheiden gelöscht werden sollen.<br>
Auf die Frage "SicherSicher?" antwortet man mit "jasicher"<br><br>


Der Lösch-Vorgang ist nicht umkehrbar - nur eine Datensicherung der Datenbankdatei kann die Daten zurückholen!<br><br>
'''

s_loesch_hilfe='''
<b>Löschen von Schülerdaten</b>
Schüler, die keinem Kurs bzw. keiner Klasse mehr zugeordnet sind, können hier auch aus der Datenbank gelöscht werden. 
<br>Verlässt ein Schüler die Schule, so muss er erst in der WinSV bzw. WinQD ausgetragen werden.
Mit dem entsprechenden Listenimport wird er auch hier aus der Klasse /dem Kurs befördert. Dann erst ist er hier zum Löschen anwählbar!<br>
'''
s_loesch_ap_hilfe='''
<b>Löschen von Attestpflicht</b>
Man kann die Attestpflicht eines Schülers hier wieder löschen. 
Dabei wird der Status vergangener Absenzen NICHT mehr geändert. 
Nur zukünftige Absenzen sind dann ohne Attestpflicht!
'''

u_loesch_hilfe='''
<b>Löschen von Lehreraccounts</b>
Lehrer, die keinem Kurs und keiner Klasse zugeordnet sind, kann man hier löschen. Legt man sie (ggf. automatisch) wieder an, 
so werden sie natürlich ein neues Passwort erhalten. User mit Sonderrechten sind nicht löschbar
 - man muss ihnen erst diese Rechte wegnehmen..
'''
k_loesch_hilfe='''
<b>Löschen von Klassen/Kursen</b>
vorgeschlagen werden alle Klassen und Kurse, die keine Schüler haben. 
Dies kann fälschlicherweise auftreten, wenn beim Listenexport existierende Klassen/Kurse vergessen wurden!
'''

vertretungs_hilfe='''
<b>Vertretungslehrer</b>
Jeder Kurs kann neben seinem Kursleiter, der über die Kurslisten definiert wird, einen Vertretungslehrer mit gleichen Rechten erhalten. Zuerst muss der Lehrer natürlich eingerichtet worden sein (wichtig z.B. bei Referendaren).
'''

klassleiter_hilfe='''
<b>Klassleiter</b>
Jede klasse kann genau einen Klassleiter haben. Der kann in diesem Dialog festgelegt werden. 
Die Einstellung bleibt auch bei einem erneuten Einlesen der Schülerlisten erhalten.<br>
Der Klassleiter hat ähnliche die Rechte wie das Sekretariat. Diese können in einem gemeinsamen Dialog festgelegt werden.
'''

terminverwalter_hilfe='''
<b>Terminverwalter</b>
... ist ein User (Lehrer, Sekretariat) der das Recht erhält allgemeine Termine einzutragen, 
während andere User auf ihre Klassenstufen (Verwalter) bzw. Klassen/Kurse beschränkt sind.
'''
gruppenrechte_hilfe='''
<b>Gruppenrechte</b>
Ein User kann zu folgenden Gruppen gehören:<br>
<ul>
    <li>Einfacher User (darf in seiner Klasse/Kurs vermissen & befreien)</li>
    <li>Klassleiter (darf entsprechend der <i>hier</i> gesetzten Gruppenrechte einiges in seiner Klasse)</li>
    <li>Sekretariat (darf entsprechend der <i>hier</i> gesetzten Gruppenrechte einiges in seiner U/M/O-Stufe)</li>
    <li>Verwalter (darf jede normale Aktion)</li>
    <li>Administrator (es kann nur einen geben - mit genau diesem Namen)</li>
</ul>
In diesem Dialog können die Rechte der Gruppen "Sekretariat" und "Klassleiter" angepasst werden. 
Die entsprechenden User müssen sich neu einloggen um die Rechte zu erhalten (oder zu verlieren)!
'''

alias_hilfe='''
<b>Alias einrichten</b>
Jeder User (i.d.R. Lehrer) hat einen Namen, unter dem er geführt wird.<br>
Sollte dieselbe Person unter einem anderen Namen auch geführt werden, so kann man dem User, 
welcher bestehen bleiben soll, den Namen (und die Verknüpfungen) des anderen Users zuweisen. 
Dieser User wird danraufhin gelöscht, der Name wird dem bestehen bleibenden User aber als Alias-Name zugewiesen, 
so dass dieser Prozess bei zukünftigen Importen nicht mehr per Hand erledigt werden muss.<br>
Löscht man einem User die Alias-Namen, so werden beim nächsten Einlesen zu den dann nicht reservierten Namen neue User angelegt. 
Diese übernehmen dann die für sie geltenden Verknüpfungen, welche in der eingelesenen Datei definiert sind.
'''
