#!/usr/bin/python3
# -*- coding: utf-8 -*-
'''
________________________________________________________________________
 a_konstanten.py                                                          
 This file is free software under         
     the terms of the GPL without any warranty - see the file COPYING 
 Diese Datei ist Freie Software gemäß
             der GPL ohne jegliche Garantie - siehe die Datei COPYING 
________________________________________________________________________

 a_konstanten.py 
________________________________________________________________________
'''

# Vorbereitende Initialisierungen
PROGRAMMVERSION='Version 2015-02-13' # nur von biec zu ändern, ggf. von Ihnen zu ergänzen
FRIST_FUER_AKTUELLE=32
FRIST_BIS_UEBERFAELLIG=8
FRIST_VON_UEBERFAELLIG=FRIST_FUER_AKTUELLE # sinnvoll, aber nicht zwingend
STATISTIK_LISTEN_LAENGE=25

#folgende Konstanten müssen streng monoton aufsteigend nummeriert sein von 0 - 20 (sonst nachfolgende Listen anpassen!)
LEVEL_GELOESCHT=0
LEVEL_SCHULBEFREIUNG=1
LEVEL_VERMISST=2
LEVEL_KRANKMELDUNG=3
LEVEL_ENTSCHULDIGUNG=4
LEVEL_ATTESTOK=5

AKTION_ATTESTPFLICHT=6
AKTION_LOESCHEN=7
AKTION_ALLGEMEINE_ATTESTPFLICHT=8
AKTION_TOGGLE_TEILFLAG=9
AKTION_GESPRAECH=10

RECHTE_TAGESLISTE=16
RECHTE_ABSENZENBLATT=17
RECHTE_STATISTIK=18
#Ende der aufsteigenden Rechte/Aktion/Level-Konstanten
# Für wieviele Rechte soll es eine Verwaltung geben?
LENRECHTE=21 # Rest siehe a_admin (Verwalten) und a_session (Rechte prüfen)

TERMIN_NAMENLAENGE=30
TERMIN_KOMMENTARLAENGE=200
TERMIN_VERANTWORTLAENGE=50
TERMIN_ZEITLAENGE=15
TERMIN_BETROFFENE=['Betroffene','Schulaufgaben-\nteilnehmer','','','','Q11','Q12','Schulleitung','Lehrer','Alle','Allgemein']
TERMIN_MAXINTERVALL=9 # Maximale Länge eines Termins

TRECHTE_NAME=['(keine)']*7+['Schulleitung','Schulleitung','Terminverwalter']
STUFENCHAR=["G","U","M","Q"]
COLOR_HIGHLIGHT='#CF8'

# STATUSCHAR ist der eingeblendete Buchstabe in der Absenzentabelle (was keinem LEVEL entspricht ist nur wg. mögl. Fehlermeldungen da)
# oder auch bei der Rechteauswahl
STATUSCHAR=['...', \
            'S','V','K','E','A', \
            '?','?','?','?','?', \
            '?','?','?','?','?', \
            'T','B','?','?','?' ] 
STATUSSTRG=['</b>(keine)<b>', \
            'Schulbefreiung','Vermisst','Krankmeldung&nbsp;ok','Entsch.&nbsp;ok','Attest&nbsp;ok', \
            'Attestpfl.&nbsp;(1&nbsp;Tag)','Löschen!','Allg.&nbsp;Attestpflicht','ganzt./stundenw.','Gespräch', 
            '?','?','?','?','?', \
            'Tagesliste','Brief','Statistiken','?','?']
STATUSSTRGLONG=['Gelöscht', \
            'Schulbefreiung erteilt','Vermisst','Krankmeldung liegt vor','Entschuldigung liegt vor','Attest liegt vor',
            'gelöscht','?','?','?','Gespräch', \
            '?','?','?','?','?', \
            'Tagesliste','Brief','?','?','?']
STATUSBG=['','lightgrey','pink','orange','green','green','red','yellow','']
STATUSDECO=['', \
            '<span style="color:lightgrey;font-size:130%"><b>☻</b></span>','<span style="color:pink"><b>?</b></span>',
                '<span style="color:orange">✔</span>','<span style="color:lightgreen">✔</span>','<span style="color:lightgreen">✔</span>',
            '<span style="color:red"><b>!</b></span>','<span style="color:red">✘</span>',
                '<span style="color:red">☂</span>','<span style="color:lightgreen"><b>½ </b></span>','<span style="color:green"><b>G</b> </span>']
atteststrg='Attest muss vorgelegt werden!'
atitlestrg=['''''',
'''Ist eine Exkursion genehmigt, so kann der betroffene Lehrer die Schüler
 seines Kurses hiermit 'schulbefreien', damit sie nicht vermisst werden.''',
'''Ein Schüler, der nicht im Unterricht erscheint, aber noch nicht krankgemeldet ist,
kann von seinem Lehrer vermisst werden. Krankmeldung und Entschuldigung muss der
Schüler damit nachliefern.''',
'''Hiermit wird das Vorliegen einer Krankmeldung bestätigt''',
'''Entschuldigung liegt vor''',
'''Hiermit wird das Vorliegen eines Attestes bestätigt''',
'''An Tagen einer Leistungserhebung besteht Attestpflicht''',
'''Sie können eine Absenz als gelöscht markieren.
Sie wird in den Statistiken nicht mehr angezeigt.''',
'''Ab einem bestimmten Datum soll für einen Schüler eine
permanente Attestpflicht gelten? Hiermit wählen Sie das Datum an/ab''',
'''Wechsel zw. ganztägig und stundenweise.\n(Eine Absenz kann ganztägig gelten (Standard) 
oder auf stundenweise gesetzt werden)''','''Hiermit kann vermerkt werden, wann ein Gespräch wg. Absenzen geführt wurde.
Erneutes Anklicken löscht wieder!''']
alphabetisch=["Aktuelle","A","B","CD","E","F","G","H","IJ","K","LM","NOPQR","S","T","UVWXYZ"]
#alphabetisch=[]
mauscursorname=['','s','v','k','e','a','ap','l','p','h','','g']
monatsname=['ungewählt','Januar','Februar','März','April','Mai','Juni','Juli','August','September','Oktober','November','Dezember']
monatstage=[0,           31,      28,       31,    30,     31,   30,    31,    31,      30,         31,       30,        31]
#Vorsicht Schalttage nicht enthalten - muss der Code hinzufügen!
wotage=['Mo','Di','Mi','Do','Fr','Sa','So']
umlautersetzungstabelle=[("ä",'ae'),("ö",'oe'),("ü",'ue'),("ß",'ss'),
    ("á","a"),("à","a"),("â","a"),("ñ","n"),("ç","c"),
    ("é","e"),("è","e"),("ê","e"),("ë","e"),
    ("í","i"),("ì","i"),("î","i"),("ï","i"),
    ("ó","o"),("ò","o"),("ô","o"),
    ("ú","u"),("ù","u"),("û","u")]

jsname={0:"alle",1:"G",5:"U",8:"M",11:"Q11",12:"Q12"}
jsname_lang={0:"Alle Jahrgangsstufen",1:"Grundschule",5:"Unterstufe",8:"Mittelstufe",11:"Oberstufe: Q11",12:"Oberstufe: Q12"}
js2stufe=[0,0,0,0,0,1,1,1, 2, 2, 2, 3, 3, 3]
jsende=  [4,4,4,4,4,7,7,7,10,10,10,11,12,13]
wunschjs={"ullg":11,"gris":12}

minimaleranfangsbuchstabenmarkierungsabstand=3

removeit=['Dr.','Dr ',',','StRefin','StRef','OStRin','OStR','StRin','StR','OStDin','OStD','StDin','StD','LAssin','LAss','Pfarrerin','Pfarrer']
